package uk.ac.bbsrc.babraham.SparkSpotter;
/*
 * SparkSpotter - An ImageJ plugin for finding bright sparks in movies
 * Copyright (c) 2007 Simon Andrews

 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */
public class DifferenceNoramlisation {

	public static int [] normalise (int [] data, int window) {

		int [] correctedData = new int[data.length];
		
		for (int i=0;i<data.length;i++) {
			
			// We're going to work in a window of 8 points, 4 either
			// side of the current point.
			
			int count = 0;
			int total = 0;
			
			for (int j=i-window;j<i;j++) {
				if (j<0) continue;
				if (j==i) continue;
				if (j==data.length) break;
			
				total += data[j];
				count++;
			}
			
			if (count == 0) {
				correctedData[i] = 0;
				continue;
			}
			
			correctedData[i] = data[i]-(total/count);
//			System.err.println("Corrected "+data[i]+" to "+correctedData[i]+" using "+count+" points");
			
		}
		
		return correctedData;
	
	}
	
}
